    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * ---------------------------------
    028 * Dimension2DObjectDescription.java
    029 * ---------------------------------
    030 * (C)opyright 2003, by Thomas Morgner and Contributors.
    031 *
    032 * Original Author:  Thomas Morgner;
    033 * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034 *
    035 * $Id: Dimension2DObjectDescription.java,v 1.2 2005/10/18 13:31:58 mungady Exp $
    036 *
    037 * Changes
    038 * -------
    039 * 13-Jan-2004 : Initial version
    040 *
    041 */
    042
    043package org.jfree.xml.factory.objects;
    044
    045import java.awt.geom.Dimension2D;
    046
    047import org.jfree.ui.FloatDimension;
    048
    049/**
    050 * An object-description for a <code>Dimension2D</code> object.
    051 *
    052 * @author Thomas Morgner
    053 */
    054public class Dimension2DObjectDescription extends AbstractObjectDescription {
    055
    056    /**
    057     * Creates a new object description.
    058     */
    059    public Dimension2DObjectDescription() {
    060        super(Dimension2D.class);
    061        setParameterDefinition("width", Float.class);
    062        setParameterDefinition("height", Float.class);
    063    }
    064
    065    /**
    066     * Creates an object based on the description.
    067     *
    068     * @return The object.
    069     */
    070    public Object createObject() {
    071        final Dimension2D dim = new FloatDimension();
    072
    073        final float width = getFloatParameter("width");
    074        final float height = getFloatParameter("height");
    075        dim.setSize(width, height);
    076        return dim;
    077    }
    078
    079    /**
    080     * Returns a parameter value as a float.
    081     *
    082     * @param param  the parameter name.
    083     *
    084     * @return The float value.
    085     */
    086    private float getFloatParameter(final String param) {
    087        final Float p = (Float) getParameter(param);
    088        if (p == null) {
    089            return 0;
    090        }
    091        return p.floatValue();
    092    }
    093
    094
    095    /**
    096     * Sets the parameters of this description object to match the supplied object.
    097     *
    098     * @param o  the object (should be an instance of <code>Dimension2D</code>).
    099     *
    100     * @throws ObjectFactoryException if the object is not an instance of <code>Point2D</code>.
    101     */
    102    public void setParameterFromObject(final Object o) throws ObjectFactoryException {
    103        if (!(o instanceof Dimension2D)) {
    104            throw new ObjectFactoryException("The given object is no java.awt.geom.Dimension2D.");
    105        }
    106
    107        final Dimension2D dim = (Dimension2D) o;
    108        final float width = (float) dim.getWidth();
    109        final float height = (float) dim.getHeight();
    110
    111        setParameter("width", new Float(width));
    112        setParameter("height", new Float(height));
    113    }
    114}